# Introduo ao R
# Temos como objetivo apresentar o software R  aos alunos de estatstica da UFPR.
# Alguns comandos teis: CTRL+C+N ou CTRL+C+P (Aperte os trs comandos juntamente) para executar a linha ou pargrafo de comando.
# Para fazer a 'flechinha' <-, basta segurar a tecla SHIFT e apertar duas vezes a tecla underline (_).
#-------------------------------------------------------------------------------------------------------------
# 1.CRIAO DE VETORES E MATRIZ

# O que  um vetor?  um objeto que armazena dados,  modo mais fcil de armazenar dados no R.

x <- c(1,2,3,4,5,6,7,8)# Criando um vetor de nmeros e atribuindo  x.
x

y <- c(1:8)# Criando o mesmo vetor acima.
y

?length # Pedindo o "help" da funo length.

length(y)# Funo que verifica o tamanho de um objeto.

# O que  matriz?  um objeto de armazenar dados igual ao vetor, exceto pela organizao em linhas colunas.

?matrix
a=matrix(data=c(1:8),nrow=2,ncol=4)# Criando uma matriz 2 por 4. "Como os elementos so arranjados?"
a
length(a)
class(a) # Funo que verifica a classe de um objeto.


?seq # Funo que gera uma sequncia.

seq(from=1,to=17,by=1)#Definir a quantidade de elementos com "l"(length)

seq(1,17,1)

seq(17)

# Exerccios
# 1. Criar uma matriz identidade 3x3.

matrix(data=c(c(1,0,0),c(0,1,0),c(0,0,1)),ncol=3,nrow=3)# Mostrar diag(1,nrow=3,ncol=3)?

q <- cbind(c(1,0,0),c(0,1,0),c(0,0,1))
q
class(q)

# 1.a Criar uma sequncia de 20 a 30, avanando em 0.5.

seq(from=20,to=30,by=0.5)

# 1.b Qual  o tamanho da sequncia acima?

length(seq(from=20,to=30,by=0.5))

#------------------------------------------------------------------------------------------
# 2. OPERAES BASICAS E DATA.FRAME

300+1245

c(300,1245)

sum(c(300,1245))

120*12
c(120,12)
prod(c(120,12))

12200+(130-1203)^4# Ou pode ser usado (130-1203)**4

(100+763)/(sqrt(2))# A funo sqrt devolva a raiz quadrada de um nmero.

a <- 99
b <- sqrt(15)
c <- 34

(c-a)/b

#Lista de funes trigonomtricas

 cos(x)
 sin(x)
 tan(x)
 acos(x)
 asin(x)
 atan(x)

# O que  dataframe?  um objeto de armazenar dados, similar a matriz, onde cada coluna pode ser tratada separadamente e conter diferentes formatos.

?data.frame

w=data.frame(Nomes=c("Estevao","Alexandra","Fillipe","Guilherme"),Conceito=c(2,4,5,6))
w
w$Conceito
w$Nomes
class(w)

d1 <- c(10:19)
d2 <- seq(1,3,length=10)

dados <- data.frame(Dias=d1,Valor=d2)
d3 <- rnorm(10)#Mostrar mean=0 e sd=1?
?rnorm
dados$d3 <- d3 # Adicionando uma nova coluna ao data.frame
dados

head(dados) # Usado para ver o cabealho da matrix ou data.frame ou vetor quando o mesmo  muito grande.
tail(dados) # Usado para ver os ultimos elementos da matrix ou data.frame ou vetor quando o mesmo  muito grande

form <- cbind(Nomes=c("Estevao","Alexandra","Fillipe","Guilherme"),Conceito=c(2,4,5,6))# O cbind nao eh reconhecido como data.frame.
class(form)
as.data.frame(form)# Reconhecendo form como data.frame.

# Armazenamento de objetos em lista.

ex1= matrix(rnorm(9),3,3)
ex2=w
ex3=dados
Lista1= list(ex1,ex2,ex3)

Lista1

Lista1[[2]]

# Exerccios
# 3. Criar um data frame com os dados abaixo, e adicionar uma coluna com a diferena entre eles.

Masculino	Feminino
50	        30
39	        28
37	        36
55              41
31	        30
25	        15
Masculino <-c(50,39,37,55,31,25)
Feminino <- c(30,28,36,41,30,15)
dif <- Masculino-Feminino

form <- data.frame(Masculino,Feminino,dif)
form

form2<- cbind(Masculino,Feminino,dif)
as.data.frame(form2)

#------------------------------------------------------------------------------------------
# 3. DISTRIBUIES DE PROBABILIDADE

#O que  distribuio de probabilidade? Eh uma funo de probabilidade que descreve a chance que uma varivel pode assumir num espao de valores.

??distribution # Para saber as distribuies de probabilidade que tem no R.

install.packages("BSDA")
require("BSDA")

# calculando rea em distribuio Normal
# entre -3sigma e 3sigma

normarea(-3, 3, 0, 1)

# entre -2sigma e 2sigma
normarea(-2, 2, 0, 1)

# entre -1sigma e 1sigma
normarea(-1, 1, 0, 1)
help(normarea)
help("dbinom")
help("curve")
x<-rbinom(100000,100,0.2)

?rbinom
y<-table(x)
barplot(prop.table(y),col="yellow")
plot(function(x)dnorm(x,mean=100*1/5,sqrt(100*(1/5)*(4/5)),log=FALSE),from=0,to=50,type="l",add=TRUE,col=2)
help("plot")# No help da funo plot h uma lista de todos os tipos de type para a funo curve e para funo plot.


#Exerccios
# 3.1 Dada a distribuio normal N(2, 6), calcule P(2<X<8) usando a funo normarea. 
normarea(2, 8, 2, 6) # com funo
pnorm(8, 2, 6)-pnorm(2, 2, 6) # sem funo


# 3.2 Dada a distribuio Normal N(20, 16), calcule P(X>23) e P(X<15).
1-pnorm(23, 20, 4) 
pnorm(23,20,4,lower.tail=FALSE)
pnorm(15, 20, 4)

# 3.3 Qual a probabilidade de uma pessoa acertar ao acaso exatamente 56 questes do vestibular da 1 fase da UFPR.
help("dbinom")
dbinom(x=56,size=80,prob=1/5)
curve(dbinom(x,size=80,prob=1/5),from=0,to=100,type="l")

# 3.4 Qual  o valor esperado de acertos na 1 fase do vestibular da UFPR?
# Lembrando que a esperan da distribuio binomial (n*prob)

esp=80*1/5
esp
curve(dbinom(x,80,1/5),from=0,to=100,type="l")
abline(v=c(esp))

x= seq(0,80,l=200)

plot(function(x)dbinom(x,80,1/5),0,100)

x=seq(0,16)

x2=dbinom(x,80,1/5)

polygon(rbind(cbind(rev(x), 0), cbind(x, x2)), col = "gray")
pbinom(q=16, size=80, prob=1/5,log=FALSE)

#3.5 Qual a probabilidade de um vestibulando acertar pelo menos 20 questes?

1-pbinom(19,80,1/5)
pbinom(19,80,1/5,lower.tail=FALSE)
x=seq(16,100)

curve(pbinom(x,80,1/5),0,100)

abline(v=19,h=pbinom(19,80,1/5))


#------------------------------------------------------------------------------------------
# 5. DESCRITIVAS

y <- c(91, 37, 84, 62, 50, 20, 37, 20, 48, 84, 91, 20)

apropos("sor") #  usado quando no lembra-se o nome completo da funo.
y <- sort(y)   # Colocando dados em ordem
length(y)      # Tamanho
sum(y)         # Soma
min(y); max(y) # Mximo e mnimo
range(y)       # Amplitude, ou seja, retorna o valor mximo e o mnimo.
mean(y)        # Calculo da mdia
median(y)      # Calculo da mediana

install.packages("prettyR")
require(prettyR)

Mode(y)        # Calculo da moda
var(y)         # Calculo da varincia
sd(y)          # Calculo da desvio padro
sd(y)/mean(y)  # Calculo da coeficiente de variao
quantile(y)    # Quartil
describe(y)
install.packages("pastecs")
require(pastecs)

help("stat.desc")
stat.desc(y) # Funo faz as descritivas todas de uma vez.
summary(y) # Algumas descritivas

# Exerccios
# 5.1 Com a seguinte amostra calcule as descritivas acima.
w <- c(59, 84, 37, 62, 10, 40, 69, 84, 38, 100)

#------------------------------------------------------------------------------------------
# 6. GRFICOS

# Argumentos de grfico: xlab - nome da abscissa, ylab - nome da ordenada, main - ttulo do grfico, col - cor

# Grfico de ramos e folhas
q <- c(10, 20, 20, 30, 40, 50, 32, 25, 45, 43, 32, 21, 33, 32, 14, 21, 32, 32, 15, 46, 34, 26)
stem(q)
help("rt")

# Histograma
t <- rt(10000, 67)# Valores aleatrios da distribuiao T de Student.
class(t)
hist(t,freq=FALSE) 
hist(t, col="yellow")# Gerando histograma com outra cor.
hist(t,freq=FALSE, col="BLUE")# Mudando nmero de intervalos.
help("hist")

# Curva
curve(dnorm(x), -5, 5,col = 2, lty = 2, lwd = 2, add = TRUE) # Curva da distribuio normal padro.
# Sobrepondo uma curva sobre o histograma para verificar normalidade dos dados.


# Box-plot
boxplot(mpg~cyl,data=mtcars, main="Car Milage Data", xlab="Number of Cylinders", ylab="Miles Per Gallon") # exemplo com dados j existentente no R.

# Colocando mais de um grfico na mesma tela.
par(mfrow=c(2,1)) # Dividindo a tela em vrios grficos.
hist(t, col="tomato", main="Grfico da distribuio t de student",freq=FALSE)
curve(dnorm(x), -5, 5, main="Curva da distribuio normal padro") # Grficos feitos anteriormente.

# Experimento Agrcola # 

soja <- read.table("http://www.leg.ufpr.br/~walmes/cursoR/soja.txt", header=TRUE, sep="\t", dec=",")
class(soja)
names(soja)
dim(soja)
str(soja)
head(soja)
soja
?subset
# grficos simples de disperso

plot(rengrao~potassio, data=soja,main="Experimento Agrcola",xlab="Dose de potssio", ylab="Rendimento de gros", col=2, pch=20, cex=1.2)
#
#------------------------------------------------------------------------------------------
# boxplot
boxplot(rengrao~potassio, data=soja, col="yellow",main = "Rendimentos de gros por dose de potassio",xlab = "Dose de potssio",ylab = "Rendimento de gros")
?plot
#
#------------------------------------------------------------------------------------------
# todos nveis de gua ao mesmo tempo
par(mfrow=c(3,1))
plot(rengrao~potassio, data=subset(soja, agua==37.5), main="37.5% de gua")
plot(rengrao~potassio, data=subset(soja, agua==50), main="50.0% de gua", col="red")
plot(rengrao~potassio, data=subset(soja, agua==62.5), main="62.5% de gua")

#biblioteca para grficos
require(lattice)
#
#------------------------------------------------------------------------------------------
# de volta aos dados de soja
?xyplot
xyplot(rengrao~potassio, groups=(agua), data=soja,auto.key=TRUE,main = "Rendimento de gros por quantidade de gua e potassio")
xyplot(rengrao~potassio, groups=agua, data=soja, type=c("p","a"),auto.key=TRUE,main = "Rendimento de gros por quantidade de gua e potassio")
xyplot(rengrao~potassio|factor(agua), data=soja, type=c("p","a"),auto.key=TRUE,main = "Rendimento de gros por quantidade de gua e potassio")
xyplot(rengrao~potassio|factor(agua), data=soja, type=c("p","smooth"),auto.key=TRUE,main = "Rendimento de gros por quantidade de gua e potassio")

#------------------------------------------------------------------------------------------
# 7. CRIANDO FUNES

# Crie uma funo que calule e retorna para o usurio a tabuada do nmero informado.
for( i in 1:100){
print(c(2*i, 3*i, 4*i, 5*i, 6*i, 7*i, 8*i, 9*i, 10*i))
}


# Crie uma funo que calcula a mdia, desvio padro e cv de um banco de dados qualquer.

dd <- function(x){
m <- mean(x)
dp <- sd(x)
cv <- dp/m
saida<-data.frame("mdia"= m, "desvio padro"= dp, "coeficiente de variao"= cv)
return(saida)
}
dados <- c(16, 42, 20, 22, 35, 18) # Dados de idade de uma turma x, qualquer.
dd(dados) # Exemplo.

# Exerccios
# 7. Crie uma funo que plot os pontos de um vetor e devolva a mdia e a variancia dos dados.
aa=function(x){
par(mfrow=c(2,1))
plot(x)
hist(x)
cat(paste("media",mean(x)),"\n")
cat(paste("variancia", var(x),"\n"))
}

aa(rnorm(100,10,23))
help("cat")


install.packages("rpanel",dep=TRUE)
require("rpanel")

# distribuição beta
# função densidade: f(x, a, b) = gamma(a+b)/(gamma(a)*gamma(b))*x^(a-1)*(1-x)^(b-1)
# suporte: 0 < x < 1
# parâmetros:  shape1 > 0  e shape2 > 0 (a=shape1, b=shape2)
# E(X) = a/(a+b) e  V(X) = a*b/((a+b)^2*(a+b+1))

beta.panel <- function(panel){
  curve(dbeta(x, shape=panel$shape1, shape2=panel$shape2), 0, 1)
  panel
}
 
panel <- rp.control()
rp.slider(panel, shape1, 0.1, 20, initval=5, showvalue=TRUE, action=beta.panel)
rp.slider(panel, shape2, 0.1, 20, initval=5, showvalue=TRUE, action=beta.panel)

# distribuição normal
# função densidade: f(x, mu, sigma) = 1/sqrt(2*pi*sigma^2)*exp(-(x-mu)/(2*sigma^2))
# suporte: -inf < x < inf
# parâmetros: -inf < mu < inf e sigma > 0
# E(X) = mu e V(X) = sigma^2

norm.panel <- function(panel){
  mu <- panel$mean
  sd <- panel$sd
  curve(dnorm(x, mean=mu, sd=sd),add=TRUE,
        from=panel$interval[1], to=panel$interval[2])
  abline(v=mu)
  arrows(mu-sd, 0, mu+sd, 0, code=3, length=0.05, angle=90)
  panel
}
 
panel <- rp.control(interval=c(0,10))
rp.slider(panel, mean, 0, 10, initval=0, showvalue=TRUE, action=norm.panel)
rp.slider(panel, sd, 0.001, 10, initval=1, showvalue=TRUE, action=norm.panel)


# distribuição beta
# função densidade: f(x, a, b) = gamma(a+b)/(gamma(a)*gamma(b))*x^(a-1)*(1-x)^(b-1)
# suporte: 0 < x < 1
# parâmetros:  shape1 > 0  e shape2 > 0 (a=shape1, b=shape2)
# E(X) = a/(a+b) e  V(X) = a*b/((a+b)^2*(a+b+1))

beta.panel <- function(panel){
  curve(dbeta(x, shape=panel$shape1, shape2=panel$shape2), 0, 1)
  panel
}
 
panel <- rp.control()
rp.slider(panel, shape1, 0.1, 20, initval=5, showvalue=TRUE, action=beta.panel)
rp.slider(panel, shape2, 0.1, 20, initval=5, showvalue=TRUE, action=beta.panel)

# distribuição gamma
# função densidade: f(x, a, s) = 1/(s^a*gamma(a))*x^(a-1)*exp(-(x/s))
# suporte: x > 0
# parâmetros:  shape > 0 e scale > 0 (shape=a, scale=s)
# E(X) = a*s e V(X) = a*s^2 

gamma.panel <- function(panel){
  shape <- panel$shape
  rate <- panel$rate
  mu <- shape/rate
  sd <- sqrt(shape/rate^2)
  curve(dgamma(x, shape=shape, rate=rate), 0, 50)
  abline(v=mu)
  arrows(mu-sd, 0, mu+sd, 0, code=3, length=0.05, angle=90)
  panel
}
 
panel <- rp.control()
rp.slider(panel, shape, 0.1, 120, initval=20, showvalue=TRUE, action=gamma.panel)
rp.slider(panel, rate, 0.1, 5, initval=5, showvalue=TRUE, action=gamma.panel)


#------------------------------------------------------------------------------------------

#Referencias

#http://leg.ufpr.br/~paulojus/embrapa/Rembrapa/

#http://www.leg.ufpr.br/doku.php/disciplinas:ce083-2012-02

#http://www.leg.ufpr.br/~walmes

# Agradecimento ao professor Walmes Zeviani (LEG-UFPR) por permitir o uso de seu material no minicurso.


